reservation/urls.py
from django.urls import path

from reservation import views

urlpatterns = [
    # homepage
    path('', views.HomePage.as_view(), name='homepage'),

    # classroom paths
    path('classes/', views.ClassroomList.as_view(), name='classroom-list'),
    path('classes/create/', views.CreateClassroom.as_view(), name='classroom-create'),
    path('classes/<int:pk>/', views.ClassroomDetail.as_view(), name='classroom-detail'),
    path('classes/<int:id>/event/', views.EventClassroomList.as_view(), name='classroom-events'),
    path('classes/<int:id>/event/<int:pk>/', views.EventDetail.as_view(), name='classroom-event'),
    path('classes/<int:id>/event/<int:pk>/update/', views.UpdateEvent.as_view(), name='classroom-event-update'),
    path('classes/<int:id>/event/<int:pk>/delete/', views.DeleteEvent.as_view(), name='classroom-event-delete'),
    path('classes/<int:id>/event/<int:pk>/equipment/', views.AddEquipment.as_view(), name='event-equipment'),
    path('classes/<int:pk>/create/', views.CreateEvent.as_view(), name='classroom-event-create'),
    path('classes/<int:pk>/update/', views.UpdateClassroom.as_view(), name='classroom-update'),
    path('classes/<int:pk>/delete/', views.DeleteClassroom.as_view(), name='classroom-delete'),

    # equipment paths
    path('equipments/', views.EquipmentListView.as_view(), name='equipment-list'),
    path('equipments/create/', views.CreateEquipment.as_view(), name='equipment-create'),
    path('equipments/<int:pk>/', views.EquipmentDetailView.as_view(), name='equipment-detail'),
    path('equipments/<int:pk>/update/', views.UpdateEquipment.as_view(), name='equipment-update'),
    path('equipments/<int:pk>/delete/', views.DeleteEquipment.as_view(), name='equipment-delete'),

    # campus paths
    path('campus/', views.CampusList.as_view(), name='campus-list'),
    path('campus/create/', views.CreateCampus.as_view(), name='campus-create'),
    path('campus/<int:pk>/', views.CampusDetail.as_view(), name='campus-detail'),
    path('campus/<int:pk>/update/', views.UpdateCampus.as_view(), name='campus-update'),
    path('campus/<int:pk>/delete/', views.DeleteCampus.as_view(), name='campus-delete'),

    # event paths
    path('event/', views.UnauthorizedEvents.as_view(), name='event-list'),
    path('event/<int:pk>/', views.UnauthorizedEventDetail.as_view(), name='event-detail'),
    path('event/<int:pk>/update/', views.UpdateUnauthorizedEvent.as_view(), name='event-update'),
    path('event/<int:pk>/delete/', views.DeleteUnauthorizedEvent.as_view(), name='event-delete'),
    path('event/<int:pk>/authorize/', views.Authorize.as_view(), name='authorize'),

    # pre-schedule and reservate
    path('classes/<int:pk>/preschedule/', views.PreSchedule.as_view(), name='pre-schedule'),
    path('classes/<int:pk>/reservate/', views.AddMultipleEvents.as_view(), name='reservate'),

    path('login/', views.LoginView.as_view(), name='login'),
    path('logout/', views.LogoutView.as_view(), name='logout')
]

settings/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from settings import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('reservation/v1/', include('reservation.urls'))
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

reservation/models.py
from abc import ABC

from django.contrib.auth.models import AbstractUser, BaseUserManager
from django.db import models


class UserManager(BaseUserManager):
    use_in_migrations = True

    def _create_user(self, email, password, **extra_fields):
        if not email:
            raise ValueError("O email é obrigatório")

        email = self.normalize_email(email)

        user = self.model(email=email, username=email, **extra_fields)
        user.set_password(password)
        user.save(using=self._db)

        return user

    def create_user(self, email, password=None, **extra_fields):
        return self._create_user(email, password, **extra_fields)

    def create_superuser(self, email, password, **extra_fields):
        extra_fields.setdefault('is_superuser', True)
        extra_fields.setdefault('is_staff', True)

        if extra_fields.get('is_superuser', True) is not True:
            raise ValueError('Superuser precisa ser superuser')
        if extra_fields.get('is_staff', True) is not True:
            raise ValueError('Superuser precisa ser staff')

        return self._create_user(email, password, **extra_fields)


class CustomUser(AbstractUser):
    possible_choices = [
        ("common", "common"),
        ("dean", "dean"),
        ("prefecture", "prefecture"),
        ("director", "director"),
        ("teacher", "teacher")
    ]
    email = models.EmailField('Email', unique=True)
    role = models.CharField(max_length=255, null=False, default="common", choices=possible_choices, blank=False)

    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['first_name', 'last_name', 'role']

    def __str__(self):
        return self.email

    objects = UserManager()


class Campus(models.Model):
    class Meta:
        default_permissions = ()

    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name


class ClassRoom(models.Model):
    class Meta:
        default_permissions = ()

    capacity = models.IntegerField(default=30)
    institution = models.ForeignKey(Campus, on_delete=models.CASCADE)

    def __str__(self):
        return str(self.pk)


class Equipment(models.Model):
    name = models.CharField(max_length=200, null=False, blank=False)
    brand = models.CharField(max_length=200, null=False, blank=False)
    serial_number = models.IntegerField(null=False, blank=False, unique=True)

    def __str__(self):
        return self.name


class Event(models.Model):
    duration = [
        (2, "2 horas"),
        (4, "4 horas"),
        (6, "6 horas"),
        (8, "8 horas"),
        (10, "10 horas"),
        (12, "12 horas")
    ]

    possible_states = [
        ("Confirmado", "Confirmado"),
        ("Aguardando confirmação", "Aguardando confirmação"),
    ]

    name = models.CharField(max_length=255, null=False, blank=False)
    date = models.DateField(blank=False, null=False)
    time = models.TimeField(blank=False, null=False)
    duration = models.IntegerField(choices=duration, blank=False, null=False)
    classroom = models.ForeignKey(ClassRoom, on_delete=models.CASCADE)
    responsible = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    status = models.CharField(max_length=255, null=False, default="Confirmado", choices=possible_states, blank=False)


class EventEquipment(models.Model):
    equipment = models.ForeignKey(Equipment, on_delete=models.CASCADE, blank=False, null=False)
    event = models.ForeignKey(Event, on_delete=models.CASCADE, blank=False, null=False)

reservation/views.py
from django.contrib import messages
from django.contrib.auth import authenticate, login, logout
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.views import View
from django.views.generic import ListView, CreateView, DetailView, UpdateView, DeleteView, TemplateView
from django.urls import reverse_lazy, reverse

from settings import settings
from .forms import *

from reservation.models import *
from reservation.validations import *
from reservation.decorators import unauthenticated_user, allowed_users


# Equipments Classes
class EquipmentListView(ListView):
    model = Equipment
    template_name = 'reservation/equipment/equipment_list.html'

    @allowed_users(["all"])
    def dispatch(self, request, *args, **kwargs):
        return super(EquipmentListView, self).dispatch(request, *args, **kwargs)


class EquipmentDetailView(DetailView):
    model = Equipment
    template_name = 'reservation/equipment/equipment_detail.html'

    @allowed_users(["all"])
    def dispatch(self, request, *args, **kwargs):
        return super(EquipmentDetailView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(EquipmentDetailView, self).get_context_data(**kwargs)

        ev_eq = EventEquipment.objects.filter(equipment=self.object)
        event_list = [reservation.event for reservation in ev_eq]

        names = [event.name for event in event_list]
        dates = [event.date.strftime("%d/%m/%Y") for event in event_list]
        times = [event.time.strftime("%H:%M") for event in event_list]

        context["Events"] = zip(names, dates, times)

        return context


class CreateEquipment(CreateView):
    model = Equipment
    template_name = 'reservation/equipment/equipment_create.html'
    form_class = CreateEquipmentForm

    @allowed_users(["director"])
    def dispatch(self, request, *args, **kwargs):
        return super(CreateEquipment, self).dispatch(request, *args, **kwargs)

    def get_success_url(self):
        class_id = self.object.pk
        return reverse_lazy('equipment-detail', kwargs={'pk': class_id})


class AddEquipment(CreateView):
    model = EventEquipment
    template_name = "reservation/event/equipment_form.html"
    form_class = AddEquipmentForm

    def form_valid(self, form):
        obj = form.save(commit=False)
        obj.event = Event.objects.get(pk=self.kwargs["pk"])

        if not validate_equipment_occupation(obj.event.date, obj.event.time, obj.equipment):
            messages.error(self.request, "Aparelho em uso")
            return super(AddEquipment, self).form_invalid(form)

        obj.save()
        return super(AddEquipment, self).form_valid(form)

    @allowed_users(["teacher", "director"])
    def dispatch(self, request, *args, **kwargs):
        return super(CreateEquipment, self).dispatch(request, *args, **kwargs)

    def get_success_url(self):
        return reverse_lazy('classroom-event', kwargs={"id": self.kwargs["id"], "pk": self.kwargs["pk"]})


class UpdateEquipment(UpdateView):
    model = Equipment
    template_name = 'reservation/equipment/equipment_update.html'
    form_class = UpdateEquipmentForm

    @allowed_users(["director"])
    def dispatch(self, request, *args, **kwargs):
        return super(UpdateEquipment, self).dispatch(request, *args, **kwargs)

    def get_success_url(self):
        return reverse_lazy('equipment-detail', kwargs={"pk": self.object.pk})


class DeleteEquipment(DeleteView):
    model = Equipment
    template_name = "reservation/create_form.html"
    success_url = reverse_lazy('equipment-list')

    @allowed_users(["director"])
    def dispatch(self, request, *args, **kwargs):
        return super(DeleteEquipment, self).dispatch(request, *args, **kwargs)


# Classroom Classes
class ClassroomList(ListView):
    model = ClassRoom
    template_name = 'reservation/classroom/classroom_list.html'

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(ClassroomList, self).get_context_data(**kwargs)
        context["object_list"] = sorted(context["object_list"], key=lambda x: x.institution.name)
        return context


class ClassroomDetail(DetailView):
    model = ClassRoom
    template_name = 'reservation/classroom/classroom_detail.html'

    def get_context_data(self, **kwargs):
        context = super(ClassroomDetail, self).get_context_data(**kwargs)

        names = [event.name for event in Event.objects.filter(classroom=self.object)]
        dates = [event.date.strftime("%d/%m/%Y") for event in Event.objects.filter(classroom=self.object)]
        times = [event.time.strftime("%H:%M") for event in Event.objects.filter(classroom=self.object)]

        context["Events"] = zip(names, dates, times)

        return context

    @allowed_users(["all"])
    def dispatch(self, request, *args, **kwargs):
        return super(ClassroomDetail, self).dispatch(request, *args, **kwargs)


class CreateClassroom(CreateView):
    model = ClassRoom
    template_name = 'reservation/classroom/classroom_create.html'
    form_class = ClassesForm
    success_url = reverse_lazy('classroom-list')

    @allowed_users(["prefecture"])
    def dispatch(self, request, *args, **kwargs):
        return super(CreateClassroom, self).dispatch(request, *args, **kwargs)

    def form_valid(self, form):
        print(form.cleaned_data.get('teste'))
        return super(CreateClassroom, self).form_valid(form)

    def get_success_url(self):
        class_id = self.object.pk
        return reverse_lazy('classroom-detail', kwargs={'pk': class_id})


class UpdateClassroom(UpdateView):
    model = ClassRoom
    template_name = 'reservation/classroom/classroom_create.html'
    form_class = UpdateClassesForm

    @allowed_users(["prefecture"])
    def dispatch(self, request, *args, **kwargs):
        return super(UpdateClassroom, self).dispatch(request, *args, **kwargs)

    def get_success_url(self):
        return reverse_lazy('classroom-detail', kwargs={"pk": self.object.pk})


class DeleteClassroom(DeleteView):
    model = ClassRoom
    success_url = reverse_lazy('classroom-list')

    @allowed_users(["prefecture"])
    def dispatch(self, request, *args, **kwargs):
        return super(DeleteClassroom, self).dispatch(request, *args, **kwargs)


# Event Classes
class UnauthorizedEvents(ListView):
    model = Event
    template_name = 'reservation/event/unauthorized_event_list.html'

    @allowed_users(["teacher", "prefecture"])
    def dispatch(self, request, *args, **kwargs):
        return super(UnauthorizedEvents, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(UnauthorizedEvents, self).get_context_data(**kwargs)
        user = self.request.user

        events = [event for event in Event.objects.filter(status="Aguardando confirmação")]

        if user.is_authenticated and user.role != "prefecture":
            events = [event for event in Event.objects.filter(status="Aguardando confirmação",
                                                              responsible=user)]

        dates = [event.date.strftime("%d/%m/%Y") for event in events]
        times = [event.time.strftime("%H:%M") for event in events]

        context["Events"] = zip(events, dates, times)
        return context


class Authorize(UpdateView):
    model = Event
    template_name = "reservation/event/event_authorize.html"
    fields = []

    @allowed_users(["prefecture"])
    def dispatch(self, request, *args, **kwargs):
        return super(Authorize, self).dispatch(request, *args, **kwargs)

    def form_valid(self, form):
        self.object.status = "Confirmado"
        return super(Authorize, self).form_valid(form)

    def get_success_url(self):
        class_id = self.object.classroom.id
        event_id = self.object.id
        return reverse_lazy('classroom-event', kwargs={"pk": event_id, "id": class_id})


class EventClassroomList(ListView):
    model = Event
    template_name = 'reservation/event/event_list.html'

    @allowed_users(["all"])
    def dispatch(self, request, *args, **kwargs):
        return super(EventClassroomList, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(EventClassroomList, self).get_context_data(**kwargs)
        context['classroom'] = ClassRoom.objects.get(pk=self.kwargs["id"])

        events = [event for event in Event.objects.filter(classroom=self.kwargs["id"], status="Confirmado")]
        dates = [event.date.strftime("%d/%m/%Y")
                 for event in Event.objects.filter(classroom=self.kwargs["id"], status="Confirmado")]
        times = [event.time.strftime("%H:%M")
                 for event in Event.objects.filter(classroom=self.kwargs["id"], status="Confirmado")]

        context["Events"] = zip(events, dates, times)

        return context


class EventDetail(DetailView):
    model = Event
    template_name = 'reservation/event/event_detail.html'

    @allowed_users(["all"])
    def dispatch(self, request, *args, **kwargs):
        return super(EventDetail, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(EventDetail, self).get_context_data(**kwargs)

        obj_list = EventEquipment.objects.filter(event=self.object)
        context['equipments'] = [obj.equipment for obj in obj_list]
        context['event_date'] = self.object.date.strftime("%d/%m/%Y")
        context['event_time'] = self.object.time.strftime("%H:%M")

        return context


class UnauthorizedEventDetail(DetailView):
    model = Event
    template_name = 'reservation/event/unauthorized_event_detail.html'

    @allowed_users(["teacher", "prefecture"])
    def dispatch(self, request, *args, **kwargs):
        return super(UnauthorizedEventDetail, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):

reservation/templates/reservation/base.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    {% load static %}
    <link
      rel="stylesheet"
      type="text/css"
      id="applicationStylesheet"
      href="{% static '/css/base.css' %}"
    />
    <title>
      {% block header %}
      {% endblock header%}
    </title>
  </head>
  <body>
    <div class="container">
      <div class="header">
        <a href="{% url 'homepage' %}">
          <div class="header__logo">
              <img class="header__image" src="{% static '/images/logo/uespi.png' %}"></img>
              <div class="header__text">
                SISTEMA DE <br />
                RESERVAS
              </div>
          </div>
        </a>
        <div class="header__navigation">
            <div class="navigation__icons">
              <img class="icons" src="{% static '/images/Classroom.svg' %}"></img>
              <a class="link" href="{% url 'classroom-list' %}">SALAS</a>
            </div>
            <div class="navigation__icons">
              <img class="icons" src="{% static '/images/Campus.svg' %}"></img>
              <a class="link" href="{% url 'campus-list' %}">CAMPUS</a>
            </div>
            <div class="navigation__icons">
              <img class="icons" src="{% static '/images/Equipments.svg' %}"></img>
              <a class="link" href="{% url 'equipment-list' %}">EQUIPAMENTOS</a>
            </div>
            <div class="navigation__icons">
              <img class="icons" src="{% static '/images/Pre_Agendar.svg' %}"></img>
              <a class="link" href="{% url 'event-list' %}">PRÉ-AGENDAR</a>
            </div>
            <div class="logout-button">
              <img src="{% static '/images/Profile.svg' %}"></img>
              {% if request.user.is_authenticated %}
                <a class="logout" href="{% url 'logout' %}">LOGOUT</a>
              {% else %}
                <a class="logout" href="{% url 'login' %}">LOGIN</a>
              {% endif %}
            </div>
        </div>
      </div>
      <hr>
      {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li {% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
            {% endfor %}
        </ul>
      {% endif %}
      {% block content %}
      {% endblock content %}
      </div>
    </div>
    <script type="text/javascript" src="{% static '/js/main.js' %}"></script>
  </body>
</html>

reservation/templates/reservation/create_form.html
{% extends "./base.html" %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Profile.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">CRIAR USUÁRIO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text">EMAIL</span>
        <input type="text" name="email" required id="id_email">
      </div>
      <div class="field">
        <span class="field__text">CARGO</span>
        <select class="select" name="role" id="id_role">
            <option value="common">Comum</option>
            <option value="dean">Reitor</option>
            <option value="prefecture">Prefeitura</option>
            <option value="director">Diretor</option>
            <option value="teacher">Professor</option>
        </select>
      </div>
      <div class="field">
        <span class="field__text">NOME</span>
        <input type="text" name="first_name" required id="id_first_name">
      </div>
      <div class="field">
        <span class="field__text">SOBRENOME</span>
        <input type="text" name="last_name" required id="id_last_name">
      </div>
      <div class="field">
        <span class="field__text">SENHA</span>
        <input type="text" name="password" required id="id_password">
      </div>
    </div>
    <button class="button" type="submit">
      <span>SALVAR</span>
      <div class="button-add">+</div>
    </button>
  </form>
</div>
{% endblock content %}

reservation/templates/reservation/create_user.html
{% extends "./base.html" %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Profile.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">CRIAR USUÁRIO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text">EMAIL</span>
        <input type="text" name="email" required id="id_email">
      </div>
      <div class="field">
        <span class="field__text">CARGO</span>
        <select class="select" name="role" id="id_role">
            <option value="common">Comum</option>
            <option value="dean">Reitor</option>
            <option value="prefecture">Prefeitura</option>
            <option value="director">Diretor</option>
            <option value="teacher">Professor</option>
        </select>
      </div>
      <div class="field">
        <span class="field__text">NOME</span>
        <input type="text" name="first_name" required id="id_first_name">
      </div>
      <div class="field">
        <span class="field__text">SOBRENOME</span>
        <input type="text" name="last_name" required id="id_last_name">
      </div>
      <div class="field">
        <span class="field__text">SENHA</span>
        <input type="text" name="password" required id="id_password">
      </div>
    </div>
    <button class="button" type="submit">
      <span>SALVAR</span>
      <div class="button-add">+</div>
    </button>
  </form>
</div>
{% endblock content %}

reservation/templates/reservation/index.html
<!DOCTYPE html>
<html>
<head>
  <meta charset='utf-8'>
  {% load static %}
  <link rel="stylesheet" type="text/css" id="applicationStylesheet" href="{% static '/css/login.css' %}"/>
  <title>Página Inicial</title>
</head>
<body class="container-home">
    <div class="header">
        <object data="{% static '/images/Profile.svg' %}"></object>
        <div class="header__text">
            {% if request.user.is_authenticated %}
                BEM-VINDO {{ request.user }} <br>
                <a href="{% url 'logout' %}" class="logout">LOGOUT</a>
            {% else %}
                Para ter acesso aos recursos faça login:<br>
                <a href="{% url 'login' %}" class="logout">LOGIN</a>
            {% endif %}
        </div>
    </div>
   <div class="content">
       <div class="logo">
           <img class="logo__image" src="{% static '/images/logo/uespi.png' %}" alt="logo">
           <span class="logo__text">SISTEMA DE RESERVAS</span>
       </div>
       <hr>
       {% if messages %}
       <ul class="messages">
            {% for message in messages %}
                <li {% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
            {% endfor %}
        </ul>
       {% endif %}
       {% load static %}
       <div class="navigation">
         <div class="navigation__icons">
             <a class="navigation-add" href="{% url 'classroom-create'%}">+</a>
             <img src="{% static '/images/Classroom.svg' %}"></img>
             <a class="navigation-text" href="{% url 'classroom-list'%}">SALAS</a>
         </div>
         <div class="navigation__icons">
             <a class="navigation-add" href="{% url 'campus-create'%}">+</a>
             <img src="{% static '/images/Campus.svg' %}"></img>
             <a class="navigation-text" href="{% url 'campus-list'%}">CAMPUS</a>
         </div>
         <div class="navigation__icons">
             <a class="navigation-add" href="{% url 'equipment-create'%}">+</a>
             <img src="{% static '/images/Equipments.svg' %}"></img>
             <a class="navigation-text" href="{% url 'equipment-list'%}">EQUIPAMENTOS</a>
         </div>
         <div class="navigation__icons">
             <a class="navigation-add" href="{% url 'event-list' %}">+</a>
             <img src="{% static '/images/Pre_Agendar.svg' %}"></img>
             <a class="navigation-text" href="{% url 'event-list' %}">SALAS EM PRÉ-AGENDAMENTO</a>
         </div>
       </div>
  </div>
</body>
</html>

reservation/templates/reservation/login.html
<!DOCTYPE html>
<html>
<head>
  <meta charset='utf-8'>
  {% load static %}
  <link rel="stylesheet" type="text/css" id="applicationStylesheet" href="{% static '/css/login.css' %}"/>
  <title>Página Inicial</title>
</head>
<body class="container-login">
  <div class="logo">
      <img class="logo__image" src="{% static '/images/logo/uespi.png' %}" alt="logo">
      <span class="logo__text">SISTEMA DE RESERVAS</span>
  </div>
  <hr>
  {% if messages %}
    <ul class="messages">
      {% for message in messages %}
      <li {% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
      {% endfor %}
    </ul>
  {% endif %}
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text">Login:</span>
        <input type="text" name="username" required id="id_login">
      </div>
      <div class="field">
        <span class="field__text">Senha:</span>
        <input type="password" name="password" required id="id_password">
      </div>
    </div>
    <div class="buttons">
      <button type="submit">CONECTAR</button>
      <a class="buttons__redirect" href="{% url 'classroom-list' %}">ENTRAR SEM LOGIN</a>
    </div>
  </form>
</body>
</html>